/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2009, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "content.h"
#include "../core/request.h"
#include "../core/error.h"
#include "../core/db.h"
#include "../core/data.h"







void Content::PostFunEmacsAdd()
{
	request.session->done = Done::added_item;
	
	request.is_item = true;
	
	if( request.session->puser )
	{
		request.item.user_id = request.session->puser->id;
	}
	else
	{
		request.item.user_id    = -1;
		request.item.guest_name = request.PostVar("guestname");
	}
	
	request.item.group_id   = -1;
	request.item.privileges = 0644; // !! tymczasowo, bedzie uzyte umask
	request.item.parent_id  = request.dir_table.back()->id;
	request.item.type       = Item::file;
	request.item.content_type = 1;// !! tymczasowo formatted text
	
	// dates (creation and modification) is set by request.item.Clear() at the beginning
	
	if( !request.CanUseEmacs(*request.dir_table.back() ) )
		throw Error(Error::permision_denied);

	request.session->done_status = db.AddItem(request.item);
}



void Content::PostFunEmacsEdit(bool with_url)
{
	request.session->done = Done::edited_item;
	
	if( !request.CanUseEmacs(request.item) )
		throw Error(Error::permision_denied);
	
	time_t t = std::time(0);
	request.item.date_modification = *std::localtime( &t );
	
	request.session->done_status = db.EditItemById(request.item, with_url);
	
	if( request.session->done_status == Error::ok )
		TemplatesFunctions::pattern_cacher.UpdatePattern(request.item);
}



void Content::PostFunEmacs()
{
bool adding = true;

	if( request.is_item )	
		adding = false;
	
	try
	{
		// these old values are ignored (if exists)
		
		//!! tymczasowo, zabezpieczenie przed pustym url-em
		try {
		request.item.url        = request.PostVar("url");
		request.item.subject    = request.PostVar("subject");
		}
		catch(...)
		{
		}

		if( request.item.subject.empty() )
			request.item.subject = request.dir_table.back()->subject;
			// !! dodac skladanie tytuly z ostatniego katalogu i liczby okreslajacej ile jest elementow w srodku
			// !! nie bedzie obciazany modul wyszukujacy bardzo
		////////
		
		request.item.content    = request.PostVar("content");

		bool with_url = false;
		
		if( !request.is_item || request.PostVar("old_url") != request.item.url )
			with_url = true;

		PrepareUrl(request.item);

		if( adding )
			PostFunEmacsAdd();
		else
			PostFunEmacsEdit(with_url);
			
	}
	catch(const Error & e)
	{
		request.session->done_status = e;
	}



	if( request.session->done_status == Error::ok )
	{
		if( data.mounts.CurrentMountType() == Mount::thread )
		{
			if( adding )
				db.EditThreadAddItem(request.dir_table.back()->id, request.item.id);
		
		
//			request.session->item = request.item;
//			request.session->done_timer = 2;
			RedirectTo(*request.dir_table.back());
		}
		else
		{		
			request.session->item = request.item;
			request.session->done_timer = 2;
			RedirectTo(request.item);
		}
	}
	else
	{
		log << log1 << "Content: PostFunEmacs: Error: " << request.session->done_status << logend;
	}
}








void Content::FunEmacs()
{
	if( !request.is_item )
	{
		// adding a new item
		if( !request.CanUseEmacs(*request.dir_table.back()) )
			request.status = Error::permision_denied;

		return;
	}

	// editing an existing item	
	if( !request.CanUseEmacs(request.item) )
	{
		request.status = Error::permision_denied;
		return;
	}
}




