/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2009, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucorerequestcontroller
#define headerfilecmslucorerequestcontroller

#include <unistd.h>
#include <sys/stat.h>
#include <iostream>
#include <sys/types.h>
#include <pwd.h>
#include <grp.h>
#include <errno.h>

#include "../content/content.h"
#include "sessionmanager.h"
#include "functionparser.h"
#include "sessioncontainer.h"


class RequestController
{
	Content content;
	SessionManager session_manager;
	
	bool BaseUrlRedirect();
	
	FunctionParser function_parser;

public:

	RequestController();
	~RequestController();
	
	bool Init();
	void Close();
	void Loop();


	SessionContainer::Iterator SessionBegin();
	SessionContainer::Iterator SessionEnd();

};


extern RequestController req_controller;

#endif
